﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using TreeDragDrop.Models;
using Infragistics.Web.Mvc;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace TreeDragDrop.Controllers
{
    public class HomeController : Controller
    {
        private NorthwindEntities db = new NorthwindEntities();

        //
        // GET: /Home/

        public ActionResult Index()
        {
            return View(db.Categories.AsQueryable());
        }

        public ActionResult Demo()
        {
            return View(db.Categories.AsQueryable());
        }

        public ActionResult Script()
        {
            return View();
        }

        public ActionResult About()
        {
            return View();
        }

        public ActionResult getData()
        {
            var result = from cat in db.Categories
                         select new
                         {
                             CategoryID = cat.CategoryID,
                             CategoryName = cat.CategoryName,
                             Products = from prod in cat.Products
                                        select new { ProductID = prod.ProductID, ProductName = prod.ProductName }
                         };
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult saveChanges()
        {
            var transactions = JsonConvert.DeserializeObject<List<JObject>>(Request.Form["ig_transactions"]);
            if (transactions.Count % 2 != 0)
            {
                return new HttpStatusCodeResult(System.Net.HttpStatusCode.Conflict);
            }
            for (var i = 0; i < transactions.Count; i+=2 )
            {
                // a single drag&drop produces 2 transactions - one removeing from the original spot and one adding to the new one.
                if (((string)transactions[i]["type"] == "addnode" && (string)transactions[i + 1]["type"] == "removenode") ||
                    ((string)transactions[i]["type"] == "removenode" && (string)transactions[i + 1]["type"] == "addnode"))
                {
                    // node was moved moved
                    if ((string)transactions[i]["tdata"]["path"] == (string)transactions[i + 1]["tdata"]["path"])
                    {
                        //merely a change in order, ignore (this will also skip category moves)
                        continue;
                    }
                    Product prod = JsonConvert.DeserializeObject<Product>(transactions[i]["tdata"]["data"].ToString());
                    var product = db.Products.Where(x => x.ProductID == prod.ProductID).Single();
                    int catId;
                    if ((string)transactions[i]["type"] == "addnode")
                    {
                        catId = int.Parse(transactions[i]["tdata"]["path"].ToString().Split('_').First());
                    }
                    else
                    {
                        catId = int.Parse(transactions[i+1]["tdata"]["path"].ToString().Split('_').First());
                    }
                    product.CategoryID = catId;
                    db.SaveChanges();
                }
            }
            // tell the data source we are cool
            Response.Write("{\"Success\": true}");
            return new JsonResult();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}